
import java.awt.*;
import java.awt.geom.*;
/**Se agrego lo necesario para dibujar el valor de la masa de la bola en draw().*/
public class GBall extends Ball implements Drawable {

    private float radius;
    private Color color = Color.BLACK;
    private Ellipse2D.Float shape = null;

    public GBall(float mass, Vector2D position, Vector2D speed,
            float radius) {
        super(mass, position, speed);
        this.radius = radius;
        setCrossSection(6 * Math.PI * radius);
        shape = new Ellipse2D.Float((float) getX() - radius, (float) getY() - radius, 2 * radius, 2 * radius);
    }
/**Para dibujar el valor se configura el color, se llama a setRenderingHints para austar el modo de rendering para ser mas adecuado para las letras, se configura la fuente y se llama a drawString con la posicion en donde se quiere dibujar.*/
    public void draw(Graphics2D g) {
        shape.setFrame((float) getX() - radius, (float) getY() - radius, 2 * radius, 2 * radius);
        g.setColor(color);
        g.fill(shape);
        Graphics2D g2 = (Graphics2D) g;
        g2.setColor(Color.WHITE);
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);
        Font font = new Font("Serif", Font.PLAIN, 10);
        g2.setFont(font);
        g2.drawString(getMass(),(int)getX()-radius*2/3, (int)getY()+radius/4);



    }

    public boolean contains(int x, int y) {
        return shape.contains(x, y);
    }

    public void dragTo(int x, int y) {
        setPosition(x, y);
    }

    public void setSelected() {
        color = Color.DARK_GRAY;
    }

    public void setReleased() {
        color = Color.BLACK;
    }
}
