import javax.swing.JFrame;
import javax.swing.*;
import java.awt.Container;
/**
@author Gabriel Juri M.
*/
/**
Lo que fue modificado con respecto a la version entregada, fue lo suiguiente (Revisar documentacion de estas):
1. Se cambio la visibilidad de los atributos de Spring a protected. 
2. Se creo la clase Rubber.
3. Se creo la clase GRubber.
4. Se creo el metodo toggleCursor() en PhysicsLabPanel.
5. En Ball y en FixedHook, se agrego el metodo detachAll.
6. En Spring se agregaron los metodos aEndIs(), bEndIs(), nullAEnd() ,nullBEnd() y detachAll().
7. En ConfigurationMenuListener se agrego el efecto para cuando se presione "Delete" y cuando se inserta un Rubber. 
8. Se agrego el metodo isRunning(), Start(), Resume(), toggleRemoveElement(), isRemoving() y removeElement() en la clase MyWorld.
9. En PhysicsLab se agregaron los menus correspondientes a Resume, Delete y Rubber.
10.En GBall, GRubber y GRubber se agrego dentro de draw() lo necesario para dibujar los valores de masas y constantes elasticas.
12.En MouseListener se modifico el metodo mouseReleased(MouseEvent).
13.En PhysicsElements se declaro el metodo reset, que fue implementado en Ball en FixedHook y en Spring.
*/
public class PhysicsLab {
   public static void main(String[] args) {
      PhysicsLabFrame labFrame = new PhysicsLabFrame();
      labFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      labFrame.setVisible(true);
   }
}

class PhysicsLabFrame extends JFrame {
   public PhysicsLabFrame() {
      setTitle("Small Physics Laboratory");
      setSize(MyWorld.WIDTH, MyWorld.HEIGHT+50);
      MyWorld world = new MyWorld();
      PhysicsLabPanel labPanel = new PhysicsLabPanel(world);
      add(labPanel);  // it is equivalent to getContentPane().add(...);
      world.setPanel(labPanel);   // to repaint view when model changes
      ConfigurationMenuListener cListener = new ConfigurationMenuListener(world);
      WorldControlMenuListener wcListener = new WorldControlMenuListener(world);
      setJMenuBar(createLabMenuBar(cListener, wcListener));
   }
/**Se agregan los items Rubber, Delete, Start y Resume a los menus correspondientes.*/
   public JMenuBar createLabMenuBar(ConfigurationMenuListener cl, WorldControlMenuListener wl) {
      JMenuBar mb = new JMenuBar();
      
      JMenu menu = new JMenu ("Configuration");
      mb.add(menu);
      JMenu subMenu = new JMenu("Insert");  
      menu.add(subMenu);     
      JMenuItem menuItem = new JMenuItem("Ball");
      menuItem.addActionListener(cl);
      subMenu.add(menuItem);
      menuItem = new JMenuItem("Fixed Hook");
      menuItem.addActionListener(cl);
      subMenu.add(menuItem);
      menuItem = new JMenuItem("Spring");
      menuItem.addActionListener(cl);
      subMenu.add(menuItem);
      menuItem = new JMenuItem("Rubber");
      menuItem.addActionListener(cl);
      subMenu.add(menuItem);
      
      menuItem = new JMenuItem("Delete");  
      menuItem.addActionListener(cl);
      menu.add(menuItem); 
      
      menu = new JMenu("MyWorld");
      mb.add(menu);
      menuItem = new JMenuItem("Resume");
      menuItem.addActionListener(wl);
      menu.add(menuItem);
      menuItem = new JMenuItem("Start");
      menuItem.addActionListener(wl);
      menu.add(menuItem);
      menuItem = new JMenuItem("Stop");
      menuItem.addActionListener(wl);
      menu.add(menuItem);
      menuItem = new JMenuItem("Gravity");
      menuItem.addActionListener(wl);
      menu.add(menuItem);
      menuItem = new JMenuItem("Viscosity");
      menuItem.addActionListener(wl);
      menu.add(menuItem);
      subMenu = new JMenu("Simulator");
      menu.add(subMenu);
      menuItem = new JMenuItem("Delta time");
      menuItem.addActionListener(wl);
      subMenu.add(menuItem);
      menuItem = new JMenuItem("Graphics Refresh time");
      menuItem.addActionListener(wl);
      subMenu.add(menuItem);
      return mb;          
   }   
}
